function [x,y] = LSOCCP_ReSNA(M,q,K,x0,y0)

%%   This file is a plugin for solving LSOCCP by means of ReSNA.
%%   For more detailed usage, please see the manual_LSOCCP_ReSNA.pdf.

%%  If [] is used for the intial point, then it is chosen randomly.

n = sum(K);
if nargin <= 4
    y0 = 2*rand(n,1) - 1;
    if nargin <=3
        x0 = 2*rand(n,1) - 1;
    end
end
if isempty(x0)
    x0 = 2*rand(n,1) - 1;
end
if isempty(y0)
    y0 = 2*rand(n,1) - 1;
end

%%  Solving by ReSNA

FUNC = @(x)(M*x+q);
nabFUNC = @(x)(M');
el = 0;
p0 = [];

[x,y,~] = ReSNA(FUNC,nabFUNC,K,el,x0,y0,p0);