function [x,y,p] = MLCP_ReSNA(M,q,el,x0,y0,p0)

%%   This file is a plugin for solving MLCP by means of ReSNA.
%%   For more detailed usage, please see the manual_MLCP_ReSNA.pdf.

%%  If [] is used for the intial point, then it is chosen randomly.

n = length(q) - el;

if nargin <= 6
    p0 = 2*rand(el,1) - 1;
    if nargin <= 5
        y0 = 2*rand(n,1) - 1;
        if nargin <=4
            x0 = 2*rand(n,1) - 1;
        end
    end
end
if isempty(x0)
    x0 = 2*rand(n,1) - 1;
end
if isempty(y0)
    y0 = 2*rand(n,1) - 1;
end
if isempty(p0)
    p0 = 2*rand(el,1) - 1;
end

%%  Solving by ReSNA

FUNC = @(x)(M*x+q);
nabFUNC = @(x)(M');
K = ones(1,n);

[x,y,p] = ReSNA(FUNC,nabFUNC,K,el,x0,y0,p0);
