function [] = nabla_checker(FUNC,nabFUNC,n,m)

times = 10;
tole_diff = 1e-6;
ab_error_vec = zeros(1,times);
re_error_vec = zeros(1,times);

for jj=1:times
    x = rand(n,1)*2-1;
    normx = 10^(rand*3-1);
    x = x/norm(x)*normx;
    ab_error_vec(jj) = ...
        norm(nabFUNC(x) - nabla_approx(FUNC,x,tole_diff,n,m));
    re_error_vec(jj) = ab_error_vec(jj) / norm(nabFUNC(x));
end
ab_mean = mean(ab_error_vec);
re_mean = mean(re_error_vec);

fprintf('\n');
fprintf('nabla_checker generates %i random vectors, and checks the difference\n',times);
fprintf('between nabFUNC(x) and its finite difference approximation.\n');
fprintf('\n');
fprintf('Then,...\n');
fprintf('The mean absolute error is %i.\n',ab_mean);
fprintf('The mean relative error is %i.\n',re_mean);
fprintf('\n');
if re_mean < tole_diff
    fprintf('Congratulations! nabFUNC(x) is considered to be the transposed Jacobian of FUNC(x).\n');
else
    fprintf('I am sorry! nabFUNC(x) is not the transposed Jacobian of FUNC(x).\n');
    fprintf('Please calculate it, again.\n');
end
fprintf('\n');


%% If you want to see the error vector, change 0 to 1.
if 0
    ab_error_vec
    re_error_vec
end


function [val] = nabla_approx(FUNC,x,tole_diff,n,m)

val = zeros(m,n);
funcx = FUNC(x);

for ii=1:n
    ei = zeros(n,1);
    ei(ii) = 1;
    val(:,ii) = (FUNC(x + tole_diff*ei)-funcx)/tole_diff;
end

val = val';
